//-------// 
/*liste.c*/ 
//-------//  

#include "Variable.h" 
#include "Error.h"
#include "Booleen.h" 
#include <stdlib.h>  
#include <string.h> 
#include <stdio.h>  

//------------------------------------------------------------------- 
//-------------------------------------------------------------------
   
//---------------------// 
/* Gestion des erreurs */ 
//---------------------//
  
// Variable globale  
Booleen erreursNonEnreg=Vrai;    
// si erreursNonEnreg=Faux, il faut enregistrer les erreurs   
// Signaler une erreur sur les liste :  

void signalerErreurListe(int erreur){ 	
    noErreur();			         
    signalerErreur(erreur); 
}  

// Enregistrer les erreurs :  

void enregistrerErreursListe(){ 	
    if (erreursNonEnreg){ 		
        enregistrerErreur(222,"La variable n'existe pas"); 		
        enregistrerErreur(244,"La mmoire n'est pas valide"); 		
        enregistrerErreur(266,"Place disponible insuffisante"); 		
        erreursNonEnreg=Faux; 	
    } 
}

//-------------------------------------------------------------------------- 
//--------------------------------------------------------------------------   

//---------------// 
/*La struct Liste*/ 
//---------------//  

struct Liste { 	
    Variable element; 	
    Liste suivant; 
} ;  
    
    Variable ListeRDL(Liste, Chaine); 
    Liste ListeSEDL(Liste, Chaine); 
    Liste ListeSuppr(Liste);
          
    
//-------------------------------------------------------------------------- 
//--------------------------------------------------------------------------          

//------------// 
/*Constructeur*/ 
//------------//  

Liste creerListe() {    
    return NULL; 
}          

//------------------------------------------------------------------------ 
//------------------------------------------------------------------------       

//---------------// 
/*Fonctionnalites*/ 
//---------------//     

/*-----------------------------*/ 
/* Teste si une liste est vide.*/ 
/*-----------------------------*/  

Booleen estVide(Liste l) { 	
    return (l==NULL); 
}    

/*---------------------------------------------*/ 
/* Renvoie la variable situe en tte de liste.*/ 
/*---------------------------------------------*/  

Variable obtenirValeur(Liste l) {      
    enregistrerErreursListe();
    noErreur();            
    if (estVide(l)) {
      	  return NULL;
       	  signalerErreurListe(222);
    }
    else {
        return l->element;
    } 
}   

/*--------------------------------------------------*/ 
/* Teste si une variable est prsente dans la liste.*/ 
/*--------------------------------------------------*/  

Booleen estPresentDansListe(Liste l, Chaine ch) 
{
 	if (estVide(l))  {
  		return Faux;
   	}
    else { 	  
        if ((strcmp((obtenirNom(obtenirValeur(l))),ch))==0) {
         		return Vrai;
        }  	  
        else {
            return estPresent(obtenirListeSuivante(l),ch);
        }
    } 
}         

/*---------------------------------------*/ 
/* Obtenir la liste suivante d'une liste.*/ 
/*---------------------------------------*/  

Liste obtenirListeSuivante(Liste l) { 	
    if (estVide(l)) {  
        return NULL;         
    }         
    else {
     	  return l->suivant;
    }
}   

/*---------------------------------------*/ 
/* Fixer la liste suivante d'une liste. */ 
/*---------------------------------------*/  

Liste fixerListeSuivante(Liste l, Liste ls) {
   if (estVide(l)){
        return ls;
   }
   else {
        l->suivant=ls;
        return l;
   }
}      

/*---------------------------------------------------------*/
/* Renvoie une variable si elle est prsente dans la liste.*/ 
/*---------------------------------------------------------*/  

Variable rechercherDansListe(Liste l, Chaine ch) {
    enregistrerErreursListe();
    noErreur();
    ListeRDL(l, ch);
} 	  

// Sous routine... rcursive...   
Variable ListeRDL(Liste l, Chaine ch) {
    if (estVide(l)){
        signalerErreurListe(222);
        return NULL; 		 	
    }  	
    else { 		
        if((strcmp(obtenirNom(obtenirValeur(l)),ch))==0) {
            return l->element;  		
        }
        else {  			
            return rechercherDansListe(obtenirListeSuivante(l),ch);
        } 	 
    }
} 	     

/*-------------------------------------*/ 
/* Supprime une variable dans la liste.*/ 
/*-------------------------------------*/  

Liste supprimerElementDansListe(Liste l, Chaine ch) {	 	         
    enregistrerErreursListe();         
    noErreur(); 	
    ListeSEDL(l, ch);  
}   

// Sous routine... rcurive...   

Liste ListeSEDL(Liste l, Chaine ch) {                     
    if (estVide(l)) { 	       
        signalerErreurListe(222);	                
        return NULL;         
    }         
    else { 		
        if ((strcmp(obtenirNom(obtenirValeur(l)),ch))==0) { 		  
        return (ListeSuppr(l)); 		
        } 		
        else { 		  
            return fixerListeSuivante(l, supprimerElementDansListe(obtenirListeSuivante(l),ch));
        }         
    }
}   

Liste ListeSuppr(Liste l) {
    Liste temp;
    temp = obtenirListeSuivante(l);
    libererVariable(l->element); 	
    free(l);		         
    return temp; 
}   

/*-------------------------------------*/ 
/* Supprime une liste.                 */ 
/*-------------------------------------*/  

void supprimerListe(Liste l) {    
    if (!estVide(l)) {           
    supprimerListe(obtenirListeSuivante(l)); 	  
    libererVariable(l->element); 	  
    free(l);		           	    
    }  
} 	  

/*--------------------------------------*/ 
/* Ajoute une variable en tte de liste.*/ 
/*--------------------------------------*/  
Liste ajouterElementDansListe(Liste l, Variable var) {                 
    Liste nouvelle; 	          
    enregistrerErreursListe();         
    noErreur();                             
    nouvelle=(Liste)malloc(sizeof(struct Liste)); 	         
    if (nouvelle==NULL) {             
        signalerErreurListe(266);         
    }                  
    else {                   		
        nouvelle->suivant=l; 	    		
        nouvelle->element=var;	 	    		
        return nouvelle; 	     
    }          
}   