/*************************************************************************************
 Projet d'algorithme
                 JEANSEN Arnaud
                 GESLIN Soizic
                 HAUTREUX Matthieu
                 LE Hoai Minh
 *************************************************************************************/

#include "Matrice.h"
 //===================================================================================//
 //Structure de Matrice
 struct Matrice
         {
         int longueur,hauteur;
         ReelInfini *lesElements;
         };
 //Remarque: les indices commencent  0

 //===================================================================================//
 //Definiton variables globales des erreurs
 int deja=0;    //deja=1 si les erreus ont t engristres


 //===================================================================================//
 //Les fonctions prives

 void signalerErreurGroupeMatrice(int erreur){
	     noErreur();
  		 signalerErreur(erreur);
 }


 //===================================================================================//
 void enregistrerLesErreurs(void){
         if (deja==0){
                 enregistrerErreur(601,"Taille impossible");
                 enregistrerErreur(602,"Erreur de la mmoire");
                 enregistrerErreur(603,"Matrice non trouve");
                 enregistrerErreur(604,"Les tailles des matrice ne sont pas compatibles");
                 enregistrerErreur(605,"L'indice est hors borne");
                 enregistrerErreur(606,"La matrice doit etre un vecteur ligne");
                 enregistrerErreur(607,"L'erreur du calcul des ReelInfini");
                 enregistrerErreur(608,"La matrice n'est pas factorisable");
                 enregistrerErreur(609,"La matrice n'est pas carre");
                 enregistrerErreur(610,"La matrice doit tre un vecteur colonne");
                 deja=1;
         }
 }


//nous allons avoir besoin de crer la matrice identit
//renvoie 601 et matrice nulle si dimension impossible
Matrice creerLaMatriceIdentite(n){
	Matrice m;
	ReelInfini zero,un;
	int i,j;
		
	enregistrerLesErreurs();
	noErreur();

	if (n<1){
		signalerErreur(601);
	}
	else{
		m=creerUneMatrice(n,n);
		zero=creerUnReelInfiniAPartirDe("0","0",'+');
		un=creerUnReelInfiniAPartirDe("1","0",'+');
		for (i=0;i<n;i++){
			for (j=0;j<n;j++){
				if (i=j){
					m=fixerLaValeurDUnElement(m,i,i,un);
				}
				else{
					m=fixerLaValeurDUnElement(m,i,j,zero);
				}
			}
		}
	}
	libererReelInfini(zero);
	libererReelInfini(un);
	return m;
}

//===================
//fonction annexe permettant la realisation de resoudreLeSysteme
int resoudreSystemeAvecMatriceDiagonale(Matrice A, Matrice secondMembre,Matrice *solution)
 {
         int i;
         ReelInfini a;
         ReelInfini b;

         ReelInfini o=creerUnReelInfiniAPartirDe("0","0",'+');

         for(i=1;i<=A->hauteur;i++)
         {
                 a =obtenirLaValeurDUnElement(A,i,i);
                 b =obtenirLaValeurDUnElement(secondMembre,i,1);

                 if (sontDeuxReelsInfinisEgaux(a,o)!=1)
                 {
                         a =diviserDeuxReelsInfinis(b,a);
                         (*solution) = fixerLaValeurDUnElement((*solution),i,1,a);
                 }
                 else
                 {
                         i=-1;
                         break;
                 }
         }
         libererReelInfini(a);
         libererReelInfini(b);
         libererReelInfini(o);
         if (i==-1)
         {
                 return 0;
         }
         else
         {
                 return 1;
         }
 }


 int resoudreSystemeAvecMatriceTriangulaireInferieur(Matrice A, Matrice secondMembre,Matrice
 *solution)
 {
         int i,j;

         ReelInfini a=obtenirLaValeurDUnElement(A,1,1);
         ReelInfini b=obtenirLaValeurDUnElement(secondMembre,1,1);
         ReelInfini o=creerUnReelInfiniAPartirDe("0","0",'+');
         ReelInfini somme=creerUnReelInfiniAPartirDe("0","0",'+');


         a =diviserDeuxReelsInfinis(b,a);
         (*solution) = fixerLaValeurDUnElement((*solution),1,1,a);

         for(i=2;i<=A->hauteur;i++)
         {
                 somme=o;
                 b =obtenirLaValeurDUnElement(secondMembre,i,1);
                 somme =additionnerDeuxReelsInfinis(somme,b);

                 for(j=1;j<=i-1;j++)
                 {
                         a =obtenirLaValeurDUnElement(A,i,j);
                         // on prend b mais en fait c'est la valeur de *solution en j
                         b =obtenirLaValeurDUnElement((*solution),j,1);
                         a =multiplierDeuxReelsInfinis(a,b);
                         somme =soustraireDeuxReelsInfinis(somme,a);
                 }

                 a =obtenirLaValeurDUnElement(A,i,i);
                 a =diviserDeuxReelsInfinis(somme,a);
                 if (sontDeuxReelsInfinisEgaux(a,o)!=1)
                 {
                         i=-1;
                         break;
                 }

                 (*solution) = fixerLaValeurDUnElement((*solution),i,1,a);

         }
         libererReelInfini(a);
         libererReelInfini(b);
         libererReelInfini(o);
         libererReelInfini(somme);
         if (i==-1)
         {
                 return 0;
         }
         else
         {
                 return 1;
         }
 }

 int resoudreSystemeAvecMatriceTriangulaireSuperieur(Matrice A, Matrice secondMembre,Matrice *solution)
 {
         int i,j;

         ReelInfini a=obtenirLaValeurDUnElement(A,A->hauteur,A->hauteur);
         ReelInfini b=obtenirLaValeurDUnElement(secondMembre,A->hauteur,1);
         ReelInfini o=creerUnReelInfiniAPartirDe("0","0",'+');
         ReelInfini somme=creerUnReelInfiniAPartirDe("0","0",'+');


         a =diviserDeuxReelsInfinis(b,a);
         (*solution) = fixerLaValeurDUnElement((*solution),A->hauteur,1,a);

         for(i=(A->hauteur-1);i>=1;i--)
         {
                 somme=o;
                 b =obtenirLaValeurDUnElement(secondMembre,i,1);
                 somme =additionnerDeuxReelsInfinis(somme,b);

                 for(j=A->hauteur;j>=i+1;j--)
                 {
                         a =obtenirLaValeurDUnElement(A,i,j);
                         // on prend b mais en fait c'est la valeur de *solution en j
                         b =obtenirLaValeurDUnElement((*solution),j,1);
                         a =multiplierDeuxReelsInfinis(a,b);
                         somme =soustraireDeuxReelsInfinis(somme,a);
                 }

                 a =obtenirLaValeurDUnElement(A,i,i);
                 a =diviserDeuxReelsInfinis(somme,a);
                 if (sontDeuxReelsInfinisEgaux(a,o)!=1)
                 {
                         i=-1;
                         break;
                 }

                 (*solution) = fixerLaValeurDUnElement((*solution),i,1,a);

         }
         libererReelInfini(a);
         libererReelInfini(b);
         libererReelInfini(o);
         libererReelInfini(somme);
         if (i==-1)
         {
                 return 0;
         }
         else
         {
                 return 1;
         }
 }

 //===================================================================================//
 //Constructeur
 //S'il y a un problme des donnes : retourne NULL et erreur 601
 //S'il y a un problme de la mmoire : retourne NULL et erreur 602
 //Retourne une Matrice si OK.
 Matrice creerUneMatrice(int  hauteur, int longueur){
         Matrice resultat;

         enregistrerLesErreurs();
         noErreur();

         //Si tailles impossibles:
         if( (hauteur<=0) || (longueur<=0)){
         signalerErreurGroupeMatrice(601);
                 return NULL;
         }
         else{
                 //Si les tailles sont ok, on alloue une zone de mmoire avec malloc:
                 resultat=(Matrice)malloc(sizeof(struct Matrice));
                 //Si malloc n'a pas march: il faut retourner NULL
                 if(resultat==NULL){
                         signalerErreurGroupeMatrice(602);
                         return NULL;
                 }
                 else{
                         resultat->hauteur     = hauteur;
                         resultat->longueur    = longueur;
                         resultat->lesElements = (ReelInfini*)malloc(hauteur*longueur*sizeof(ReelInfini));
                         if (resultat->lesElements==NULL){
                                 signalerErreurGroupeMatrice(602);
                                 free(resultat);
                                 return NULL;
                         }
                         else{
                                 return resultat ;
                         }
                 }
         }
 }

 //==========
 //Destructeur
 //Retourne erreur 603 si m est introuvable
 void detruireUneMatrice(Matrice m){
         int i,j;

         enregistrerLesErreurs();
         noErreur();

         //Si m est introuvable
         if (m==NULL){
                 signalerErreurGroupeMatrice(603);
         }
         else{
                 for (i=0;i< m->hauteur;i++)
                 for (j=0;j< m->longueur;j++)
                         libererReelInfini((m->lesElements[i*m->longueur+j]));
          if (verifierErreur()){
             noErreur();
             signalerErreurGroupeMatrice(607);
         }
         free(m);
         }
 }


 /*===============================Fonctions permettant d'obtenir les informations======*/

 //==========
 //Retourne -1 et erreur 603 si m est introuvable
 int obtenirLaHauteur(Matrice m){

         enregistrerLesErreurs();
         noErreur();

         //Si m est introuvable
         if (m==NULL){
                 signalerErreurGroupeMatrice(603);
                 return (-1);
         }
         //Sinon:OK
         else{
                 return (m->hauteur);
         }
 }


 //==========
 //Retourne -1 et erreur 603 si m est introuvable
 int obtenirLaLongueur(Matrice m){
         enregistrerLesErreurs();
         noErreur();

         //Si m est introuvable
         if (m==NULL){
                 signalerErreurGroupeMatrice(603);
                 return (-1);
         }
         //Sinon:OK

         else{
                 return (m->longueur);
         }
 }


 //==========
 //Retourne erreur 603 si m est introuvable
ReelInfini obtenirLeDeterminant(Matrice m){
  int i;
	ReelInfini determinant;
  Matrice L,U;
	enregistrerLesErreurs();
	noErreur();

        //Si m est introuvable
	if (m==NULL){
		signalerErreurGroupeMatrice(603);
		return -1;
	}
	//Sinon:calcul du dterminant en passant par une dcomposition LU
        determinant = creerUnReelInfiniAPartirDe("1","0",'+');
        L = creerUneMatrice(m->hauteur,m->longueur);
        U = creerUneMatrice(m->hauteur,m->longueur);

        if (factoriserLU(m,&L,&U)==1){
                for(i=0;i<m->hauteur;i++) {
                        determinant = multiplierDeuxReelsInfinis(determinant,multiplierDeuxReelsInfinis(obtenirLaValeurDUnElement(L,i,i),obtenirLaValeurDUnElement(U,i,i)));
                        //le determinant d'une matrice carre triangulaire est gal au produit des lments diagonaux
                        //L et U sont dans ce cas, et de plus, det(m) = det(L)*det(U), d'o cette formule
                }
                return determinant;
        }
        else {
                return 0;
        }


}



 //==========
 //Retourne erreur 603 si m est introuvable
 //Retourne erreur 605 si indice est hors borne
 ReelInfini obtenirLaValeurDUnElement(Matrice m,int indiceLigne,int indiceColonne){
         enregistrerLesErreurs();
         noErreur();

         //Si m est introuvable
         if (m==NULL){
                 signalerErreurGroupeMatrice(603);
                 return creerUnReelInfiniAPartirDe("0","0",'+');
         }
         else{
                 //Si indice est hors borne
                 if ((indiceLigne<0) || (indiceLigne >= (m->hauteur)) || (indiceColonne<0) || (indiceColonne >=(m->longueur))){
                         signalerErreurGroupeMatrice(605);
                         return creerUnReelInfiniAPartirDe("0","0",'+');
                 }
                 //Sinon:OK
                 else{
                         return (m->lesElements[indiceLigne*m->longueur + indiceColonne]);
                 }
         }
 }


 //==========
 //Retourne NULL et erreur 603 si m est introuvable
 //Retourne NULL et erreur 605 si indice est hors borne
 Matrice obtenirUneColonne(Matrice m, int indiceColonne){
         Matrice resultat;
         int i;

         enregistrerLesErreurs();
         noErreur();

         //Si m est introuvable
         if(m==NULL){
                 signalerErreurGroupeMatrice(603);
                 return NULL;
         }
         else{
                 //Si l'indice est hors borne
                 if ((indiceColonne<0) || (indiceColonne >= (m->longueur))){
                         signalerErreurGroupeMatrice(605);
                         return NULL;
                 }
                 //Sinon:OK
                 else{
                         resultat=creerUneMatrice(m->hauteur,1);
                          //S'il y a une erreur lorsqu'on cree une nouvelle matrice
                          if (verifierErreur()){
                                 return NULL;
                          }
                            else{
                                 for (i=0;i<m->hauteur;i++){
                                 			resultat=fixerLaValeurDUnElement(resultat,i,1,obtenirLaValeurDUnElement(m,i,indiceColonne));
                                 }
                                 return (resultat);
                          }
                 }
         }
 }


 //==========
 //Retourne NULL et erreur 603 si m est introuvable
 //Retourne NULL et erreur 605 si indice est hors borne
 Matrice obtenirUneLigne(Matrice m, int indiceLigne){
         Matrice resultat;
         int i;

         enregistrerLesErreurs();
         noErreur();

         //Si m est introuvable
         if(m==NULL){
                 signalerErreurGroupeMatrice(603);
                 return NULL;
         }
         else{
                 //Si l'indice est hors borne
                 if ((indiceLigne<0) || (indiceLigne >= (m->hauteur))){
                         signalerErreurGroupeMatrice(605);
                         return NULL;
                 }
                 //Sinon:OK
                 else{
                         resultat=creerUneMatrice(1,m->longueur);
                         //S'il y a une erreur lorsqu'on cree une nouvelle matrice
                          if (verifierErreur()){
                                 return NULL;
                          }
                          else{
                                 for (i=0;i<m->longueur;i++){
                                         resultat=fixerLaValeurDUnElement(resultat,1,i,obtenirLaValeurDUnElement(m,indiceLigne,i));
                                 }
                                 return (resultat);
                          }
                 }
         }
 }


 //==========
 //Retourne NULL et erreur 603 si m est introuvable
 //Retourne NULL et erreur 605 si indice est hors borne
 Matrice obtenirUneSousMatrice(Matrice m, int indicePremiereLigne,
           int indicePremiereColonne,int indiceDerniereLigne,int indiceDerniereColonne){
                   int i,j;
         Matrice resultat;

         enregistrerLesErreurs();
         noErreur();


         //Si m est introuvable
         if (m==NULL){
                 signalerErreurGroupeMatrice(603);
                 return NULL;
         }
         else{
                 //Si l'indice est hors borne
                 if ((indicePremiereLigne<0)||(indicePremiereLigne>indiceDerniereLigne)||
                          (indicePremiereColonne<0)||(indicePremiereColonne>indiceDerniereColonne)||
                          (indiceDerniereLigne<0)||(indiceDerniereLigne>m->hauteur)||
                          (indiceDerniereColonne<0)||(indiceDerniereColonne>m->longueur)){
                         signalerErreurGroupeMatrice(605);
                         return NULL;
                 }
                 else{
												 resultat=creerUneMatrice(indiceDerniereLigne-indicePremiereLigne+1,indiceDerniereColonne-indicePremiereColonne+1);
                         //S'il y a une erreur lorsqu'on cree une nouvelle matrice
                         if (verifierErreur()){
                                 signalerErreurGroupeMatrice(602);
                                 return NULL;
                         }
                         else{
                                 for(i=0;i<resultat->hauteur;++i){
                                         for(j=0;j<resultat->longueur;++j){
                                         				 resultat=fixerLaValeurDUnElement(resultat,i,j,obtenirLaValeurDUnElement(m,i+indicePremiereLigne,j+indicePremiereColonne));
                                         }
                                 }
                                 return resultat;
                         }
                 }
         }
 }


 //==========
 //Retourne 1 si m est une matrice carree
 //Retourne 0 si non
 //Retourn -1 et erreur 603 si m est non trouvable
 int estUneMatriceCarree
 (Matrice m){
         enregistrerLesErreurs();
         noErreur();

         //Si m est introuvable
         if (m==NULL){
                 signalerErreurGroupeMatrice(603);
                 return -1;
         }
         else{
                 if(m->longueur==m->hauteur){
                         return 1;
                 }
                 else{
                         return 0;
                 }
         }
 }


 //==========
 //Retourne 1 si m est une matrice triangulaire suprieure
 //Retourne 0 si non
 //Retourn -1 et erreur 603 si m est non trouvable
 //Retourn -1 et erreur 609 si m n'est pas carre
 //Retourn -1 et erreur 607 s'il y a une erreur du ReelInfini
 int estUneMatriceTriangulaireSuperieure(Matrice m){
         ReelInfini zero;
         int resultat=1;
         int i,j;

         enregistrerLesErreurs();
         noErreur();

         //Si m est introuvable
         if (m==NULL){
                 signalerErreurGroupeMatrice(603);
                 return -1;
         }
         else{
                 //Si m n'est pas carre
                 if(m->hauteur!=m->longueur){
                         signalerErreurGroupeMatrice(609);
                         return -1;
                         }
                 else{
                         zero=creerUnReelInfiniAPartirDe("0","0",'+');
                         i=0;
                         while ((i<m->hauteur) && (resultat==1)){
                                 j=0;
                                 while ((j<i) && (resultat==1)){
                                         if (!sontDeuxReelsInfinisEgaux(zero,obtenirLaValeurDUnElement(m,i,j))){
                                                 if (verifierErreur()){
                                                         signalerErreurGroupeMatrice(607);
                                                         return -1;
                                                 }
                                                 resultat=0;
                                   }
                                         j++;
                                 }
                                 i++;
                         }
                         return resultat;
                 }
         }
 }


 //==========
 //Retourne 1 si m est une matrice triangulaire infrieure
 //Retourne 0 si non
 //Retourn -1 et erreur 603 si m est non trouvable
 //Retourn -1 et erreur 607 s'il y a une erreur du ReelInfini
 int estUneMatriceTriangulaireInferieure(Matrice m){
         int resultat=1;
         int i,j;
         ReelInfini zero;

         enregistrerLesErreurs();
         noErreur();

         //Si m est introuvable
         if (m==NULL){
     signalerErreurGroupeMatrice(603);
                 return -1;
         }
         else{
                 //Si m n'est pas carre
                 if(m->hauteur!=m->longueur){
                         signalerErreurGroupeMatrice(609);

                         return -1;
                 }
                 else{
                         zero=creerUnReelInfiniAPartirDe("0","0",'+');
                         i=0;
                         while ((i<m->hauteur) && (resultat==1)){
                                 j=i+1;
                                 while ((j<m->longueur) && (resultat==1)){
                                         if (!sontDeuxReelsInfinisEgaux(zero,obtenirLaValeurDUnElement(m,i,j))){
                                                 if (verifierErreur()){
                                                         signalerErreurGroupeMatrice(607);
                                                         return -1;
                                                 }
                                                 resultat=0;
                                         }
                                         j++;
                                 }
                                 i++;
                         }
                         return resultat;
                 }
         }
 }


 //==========
 //Retourne 1 si m est une matrice diagonale
 //Retourne 0 si non
 //Retourn -1 et erreur 603 si m est non trouvable
 int estUneMatriceDiagonale(Matrice m){
         enregistrerLesErreurs();
         noErreur();

         //Si m est introuvable
         if (m==NULL){
                 signalerErreurGroupeMatrice(603);
                 return -1;
         }
         else{
                 if (estUneMatriceTriangulaireInferieure(m) && estUneMatriceTriangulaireSuperieure(m))
                         return 1;
                 else
                         return 0;
         }
 }


 //==========
 //Retourne 1 si m est une matrice symtrique
 //Retourne 0 si non
 //Retourn -1 et erreur 603 si m est non trouvable
 int estUneMatriceSymetrique(Matrice m){
         int resultat=1;
         int i,j;

         enregistrerLesErreurs();
         noErreur();

         //Si m est introuvable
         if (m==NULL){
                 signalerErreurGroupeMatrice(603);
                 return -1;
         }
         else{
                 i=0;
                 while ((i<m->hauteur) && (resultat==1)){
                         j=0;
                         while ((j<i) && (resultat==1)){
                                 if (!sontDeuxReelsInfinisEgaux(obtenirLaValeurDUnElement(m,j,j),obtenirLaValeurDUnElement(m,i,j)))
                                         resultat=0;
                                 j++;
                         }
                         i++;
                 }
                 return resultat;
         }
 }


 //==========
 //Retourne 1 si m est une matrice ligne
 //Retourne 0 si non
 //Retourne -1 et erreur 603 si m est non trouvable
 int estUneMatriceLigne(Matrice m){
         enregistrerLesErreurs();
         noErreur();

         //Si m est introuvable
         if (m==NULL){
                 signalerErreurGroupeMatrice(603);
                 return -1;
         }
         else{
                 if (m->hauteur==1){
                         return 1;
                 }
                 else{
                         return 0;
                 }
         }
 }


 //==========
 //Retourne 1 si m est une matrice colonne
 //Retourne 0 si non
 //Retourne -1 et erreur 603 si m est non trouvable
 int estUneMatriceColonne(Matrice m){
         enregistrerLesErreurs();
         noErreur();

         //Si m est introuvable
         if (m==NULL){
                 signalerErreurGroupeMatrice(603);
                 return -1;
         }
         else{
                 if (m->longueur==1){
                         return 1;
                 }
                 else{
                         return 0;
                 }
         }
 }


 /*===============================Manipulation de la matrice==========================*/

 //==========
 //Retourne NULL et erreur 603 si m est introuvable
 //Retourne m et erreur 605 si indice est hors borne
 Matrice fixerLaValeurDUnElement(Matrice m,int indiceLigne,int indiceColonne,ReelInfini
 valeurElement){
         enregistrerLesErreurs();
         noErreur();

         //Si m est introuvable

         if (m==NULL){
                 signalerErreurGroupeMatrice(603);
                 return NULL;
         }
         else{
                 //Si indice est hors borne
                 if ((indiceLigne<0) || (indiceLigne >= (m->hauteur)) || (indiceColonne<0) || (indiceColonne >= (m->longueur))){
                         signalerErreurGroupeMatrice(605);
                         return m;
                 }
                 //Sinon:OK
                 else{
                         m->lesElements[indiceLigne*m->longueur + indiceColonne]=valeurElement;
                         return m;
                 }
         }
 }


 //==========
 //Retourne NULL et erreur 603 si m est introuvable
 //Retourne m et erreur 603 si colonne est introuvable
 //Retourne m et erreur 605 si indice est hors borne
 //Retourne m et erreur 604 si les tailles ne sont pas compatibles
 //Retourne m et erreur 610 si colonne n'est pas un vecteur colonne
 Matrice fixerUneColonne(Matrice m,Matrice colonne,int indiceColonne){
         int i;

         enregistrerLesErreurs();
         noErreur();

         //Si m est introuvable
         if (m==NULL){
                 signalerErreurGroupeMatrice(603);
                 return NULL;
         }
         else{
                 //Si colonne est introuvable
                 if (colonne==NULL){

                         signalerErreurGroupeMatrice(603);
                         return m;
                 }
                 else{
                         //Si indice est hors borne
                         if ((indiceColonne<0) || (indiceColonne >= (m->longueur))){
                                 signalerErreurGroupeMatrice(605);
                                 return m;
                         }
                         else{
                                 //Si les tailles ne sont pas compatibles
                                 if (m->hauteur!=colonne->hauteur){
                                         signalerErreurGroupeMatrice(604);
                                         return m;
                                 }
                                 else{
                                         //Si colonne n'est pas un vecteur colonne
                                         if (colonne->longueur!=1){
                                                 signalerErreurGroupeMatrice(610);
                                                 return m;
                                         }
                                         else{
                                                 for(i=0;i<m->hauteur;i++){
                                                         m=fixerLaValeurDUnElement(m,i,indiceColonne,obtenirLaValeurDUnElement(colonne,i,1));
                                                 }

                                                 return m;
                                         }
                                 }
                         }
                 }
         }
 }


 //==========
 //Retourne NULL et erreur 603 si m est introuvable
 //Retourne m et erreur 603 si ligne est introuvable
 //Retourne m et erreur 605 si indice est hors borne
 //Retourne m et erreur 604 si les tailles ne sont pas compatibles
 //Retourne m et erreur 606 si ligne n'est pas un vecteur
 Matrice fixerUneLigne(Matrice m,Matrice ligne,int indiceLigne){
         int i;

         enregistrerLesErreurs();
         noErreur();

         //Si m est introuvable
         if (m==NULL){
                 signalerErreurGroupeMatrice(603);
                 return NULL;
         }
         else{
                 //Si ligne est introuvable
                 if (ligne==NULL){
                         signalerErreurGroupeMatrice(603);
                         return m;
                 }
                 else{
                         //Si indice est hors borne
                         if ((indiceLigne<0) || (indiceLigne >= (m->hauteur))){
                                 signalerErreurGroupeMatrice(605);
                                 return m;
                         }
                         else{
                                 //Si les tailles ne sont pas compatibles
                                 if (m->longueur!=ligne->longueur){
                                         signalerErreurGroupeMatrice(604);
                                         return m;
                                 }
                                 else{
                                         //Si ligne n'est pas un vecteur ligne
                                         if (ligne->hauteur!=1){
                                                 signalerErreurGroupeMatrice(610);
                                                 return m;
                                         }
                                         else{
                                                 for(i=0;i<m->longueur;i++){
                                                         m=fixerLaValeurDUnElement(m,indiceLigne,i,obtenirLaValeurDUnElement(ligne,1,i));
                                                 }
                                                 return m;
                                         }
                                 }
                         }
                 }
         }
 }


 //==========
 //Retourne m et erreur 603 si m ou mAinserer est introuvable
 //Retourne m et erreur 605 si indice est hors borne
 Matrice fixerUneSousMatrice(Matrice m,Matrice mAInserer,int indicePremiereLigne,
                 int indicePremiereColonne, int indiceDerniereLigne,int indiceDerniereColonne){
         int i,j;

         enregistrerLesErreurs();
         noErreur();

         //Si m ou mAinserer est introuvable
         if ((m==NULL)||(mAInserer==NULL)){
                 signalerErreurGroupeMatrice(603);
                 return m;
         }
         else{
                 //Si la taille de mAinserer est plus grande celle de m
                 if ((m->longueur<mAInserer->longueur)||(m->hauteur<mAInserer->hauteur)){
                         signalerErreurGroupeMatrice(604);
                         return m;
                 }
                 else{
                         //Si l'indice est hors borne
                         if ((indicePremiereLigne<0)||(indicePremiereLigne>indiceDerniereLigne)||
                                  (indicePremiereColonne<0)||(indicePremiereColonne>indiceDerniereColonne)||
                                  (indiceDerniereLigne<0)||(indiceDerniereLigne>m->hauteur)||
                                  (indiceDerniereColonne<0)||(indiceDerniereColonne>m->longueur)||
                                  ((indiceDerniereLigne-indicePremiereLigne+1)!=mAInserer->hauteur)||
                                  ((indiceDerniereColonne-indicePremiereColonne+1)!=mAInserer->longueur)){
                                 signalerErreurGroupeMatrice(605);
                                 return m;
                         }
                         else{
                                 for(i=0;i<mAInserer->hauteur;++i){
                                         for(j=0;j<mAInserer->longueur;++j){
                                         				xerLaValeurDUnElement(m,i+indicePremiereLigne,j+indicePremiereColonne,obtenirLaValeurDUnElement(mAInserer,i,j));
                                         }
                                 }
                                 return m;
                         }
                 }
         }
 }


 //==========
 //Retourne NULL et erreur 603 si m est introuvable
 //Retourne m et erreur 605 si indice est hors borne
 Matrice permuterDeuxColonnes(Matrice m,int indiceColonne1,int indiceColonne2){
         Matrice temp;


         enregistrerLesErreurs();
         noErreur();

         //Si m est introuvable
         if (m==NULL){
                 signalerErreurGroupeMatrice(603);
                 return NULL;
         }
         else{
                 //Si l'indices est hors borne
                 if
 ((indiceColonne1<0)||(indiceColonne1>m->longueur)||(indiceColonne2<0)||(indiceColonne2>m->longueur)){
                         signalerErreurGroupeMatrice(605);
                         return m;
                 }
                 else{
                         temp=obtenirUneColonne(m,indiceColonne1);
                         m=fixerUneColonne(m,obtenirUneColonne(m,indiceColonne2),indiceColonne1);
                         m=fixerUneColonne(m,temp,indiceColonne2);
          detruireUneMatrice(temp);
          return m;
                 }
         }
 }


 //==========
 //Retourne NULL et erreur 603 si m est introuvable
 //Retourne m et erreur 605 si indice est hors borne
 Matrice permuterDeuxLignes(Matrice m,int indiceLigne1,int indiceLigne2){
         Matrice temp;

         enregistrerLesErreurs();
         noErreur();

         //Si m est introuvable
         if (m==NULL){
                 signalerErreurGroupeMatrice(603);
                 return NULL;
         }
         else{
                 //Si l'indices est hors borne
                 if ((indiceLigne1<0)||(indiceLigne1>m->hauteur)||(indiceLigne2<0)||(indiceLigne2>m->hauteur)){
                         signalerErreurGroupeMatrice(605);
                         return m;
                 }
                 else{
                         temp=obtenirUneLigne(m,indiceLigne1);
                         m=fixerUneLigne(m,obtenirUneLigne(m,indiceLigne2),indiceLigne1);
                         m=fixerUneLigne(m,temp,indiceLigne2);
                         detruireUneMatrice(temp);
                         return m;
                 }
         }
 }


 /*===============================Calcul sur la Matrice===============================*/

 //==========
 //Retourne NULL et erreur 604 si les tailles de m1 et m2 ne sont pas compatibles
 //Retourne NULL et erreur 603 si l'une des deux matrices(ou toutes les deux
 //est(sont) introuvable(s)
 Matrice additionnerDeuxMatrices(Matrice m1,Matrice m2){
         Matrice resultat;
         int i,j;

         enregistrerLesErreurs();
         noErreur();

         if ((m1==NULL)||(m2==NULL)){
                 signalerErreurGroupeMatrice(603);
                 return NULL;
         }
         else{
                 //Si les tailles de m1 et m2 ne sont pas compatibles
                 if ((m1->longueur!=m2->longueur)||(m1->hauteur!=m2->hauteur)){
                         signalerErreurGroupeMatrice(604);
                         return NULL;
                 }
                 else{
                         resultat=creerUneMatrice(m1->longueur,m1->hauteur);
                         //S'il y a une erreur lorsqu'on cree une nouvelle matrice
                         if (verifierErreur()){
                                 return NULL;
                         }
                         else{
                                 for(i=0;i<m1->hauteur;++i){
                                         for(j=0;j<m1->longueur;++j){
                                         				 resultat=fixerLaValeurDUnElement(resultat,i,j,additionnerDeuxReelsInfinis(obtenirLaValeurDUnElement(m1,i,j),obtenirLaValeurDUnElement(m2,i,j)));
                                                 //S'il y a erreur lorsqu'on utilise les fonctions des ReelInfini
                                                 if(verifierErreur()){
                                                         detruireUneMatrice(resultat);
                                                         signalerErreurGroupeMatrice(607);
                                                         return NULL;
                                                 }
                                         }
                                 }
                                 return resultat;
                         }
                 }
         }
 }


 //==========
 //Retourne NULL et erreur 604 si es tailles de m1 et m2 ne sont pas compatibles
 //Retourne NULL et erreur 603 si l'une des deux matrices(ou toutes les deux) est(sont) introuvable(s)
 Matrice multiplierDeuxMatrices(Matrice m1,Matrice m2){
         Matrice resultat;
         ReelInfini somme;
         int i,j,k;

         enregistrerLesErreurs();
         noErreur();

         if ((m1==NULL)||(m2==NULL)){
                 signalerErreurGroupeMatrice(603);
                 return NULL;
         }
         else{
                 //Si les tailles de m1 et m2 ne sont pas compatibles
                 if (m1->longueur!=m2->hauteur){
                         signalerErreurGroupeMatrice(604);
                         return NULL;
                 }
                 else{
                         resultat=creerUneMatrice(m1->hauteur,m2->longueur);
                         //S'il y a une erreur lorsqu'on cree une nouvelle matrice
                         if (verifierErreur()){
                                 return NULL;
                         }
                         else{
                                 for(i=0;i<resultat->hauteur;++i){
                                         for(j=0;j<resultat->longueur;++j){
                                                 somme=creerUnReelInfiniAPartirDe("0","0",'+');
                                                 for(k=0;k<m1->longueur;++k){
                                                 				 somme=additionnerDeuxReelsInfinis(somme,multiplierDeuxReelsInfinis(obtenirLaValeurDUnElement(m1,i,k),obtenirLaValeurDUnElement(m2,k,j)));
                                                         //S'il y a erreur lorsqu'on utilise les fonctions des ReelInfini
                                                         if(verifierErreur()){
                                                                 detruireUneMatrice(resultat);
                                                                 signalerErreurGroupeMatrice(607);
                                                                 return NULL;
                                                         }
                                                         resultat=fixerLaValeurDUnElement(resultat,i,j,somme);
                                                 }
                                         }
                                 }
                                 libererReelInfini(somme);
                                 return resultat;
                         }
                 }
         }
 }


 //==========
 //Retourne NULL et erreur 604 si es tailles de m1 et m2 ne sont pas compativbles
 //Retourne NULL et erreur 603 si l'une des deux matrices(ou toutes les deux) est(sont) introuvable(s)
 Matrice multiplierTermeATermeDeuxMatrices(Matrice m1,Matrice m2){
         Matrice resultat;
         int i,j;

         enregistrerLesErreurs();
         noErreur();

         if ((m1==NULL)||(m2==NULL)){
                 signalerErreurGroupeMatrice(603);
                 return NULL;
         }
         else{
                 //Si les tailles de m1 et m2 ne sont pas compatibles
                 if ((m1->longueur!=m2->longueur)||(m1->hauteur!=m2->hauteur)){
                         signalerErreurGroupeMatrice(604);
                         return NULL;
                 }
                 else{
                         resultat=creerUneMatrice(m1->hauteur,m1->longueur);
                         //S'il y a une erreur lorsqu'on cree une nouvelle matrice
                         if (verifierErreur()){
                                 return NULL;
                         }
                         else{
                                 for(i=0;i<m1->hauteur;++i){
                                         for(j=0;j<m1->longueur;++j){
                                         				 resultat=fixerLaValeurDUnElement(resultat,i,j,multiplierDeuxReelsInfinis(obtenirLaValeurDUnElement(m1,i,j),obtenirLaValeurDUnElement(m2,i,j)));
                                                 //S'il y a erreur lorsqu'on utilise les fonctions des ReelInfini
                                                 if(verifierErreur()){
                                                         detruireUneMatrice(resultat);
                                                         signalerErreurGroupeMatrice(607);
                                                         return NULL;
                                                 }
                                         }
                                 }
                                 return resultat;
                         }
                 }
         }
 }


 //==========
 //Retourne NULL et erreur 603 si m est introuvable
 Matrice multiplierUneMatriceParUnScalaire(Matrice m,ReelInfini scalaire){
         Matrice resultat;
         int i,j;

         enregistrerLesErreurs();
         noErreur();

         if (m==NULL){
                 signalerErreurGroupeMatrice(603);
                 return NULL;
         }
         else{
                 resultat=creerUneMatrice(m->longueur,m->hauteur);
                 //S'il y a une erreur lorsqu'on cree une nouvelle matrice
                 if (verifierErreur()){
                         return NULL;
                 }
                 else{
                         for(i=0;i<m->hauteur;++i){
                                 for(j=0;j<m->longueur;++j){
                                 				 resultat=fixerLaValeurDUnElement(resultat,i,j,multiplierDeuxReelsInfinis(obtenirLaValeurDUnElement(m,i,j),scalaire));
                                         //S'il y a erreur lorsqu'on utilise les fonctions des ReelInfini
                                         if(verifierErreur()){
                                                 detruireUneMatrice(resultat);
                                                 signalerErreurGroupeMatrice(607);
                                                 return NULL;
                                         }
                                 }
                         }
                         return resultat;
                 }
         }
 }


 //==========
 //Retourne NULL et erreur 603 si m est introuvable
 Matrice calculerLaMatriceDiagonale(Matrice m){
         Matrice resultat;
         ReelInfini zero;
         int i,j;

         enregistrerLesErreurs();
         noErreur();

         if (m==NULL){
                 signalerErreurGroupeMatrice(603);
                 return NULL;
         }
         else{
                 if(m->hauteur!=m->longueur){
                         signalerErreurGroupeMatrice(609);
                         return NULL;
                 }
                 else{
                         resultat=creerUneMatrice(m->hauteur,m->hauteur);
                         //S'il y a une erreur lorsqu'on cree une nouvelle matrice
                         if(verifierErreur()){
        												 signalerErreurGroupeMatrice(602);
                                 return NULL;
                         }
                         else{
                                 zero=creerUnReelInfiniAPartirDe("0","0",'+');
                                 for(i=0;i<m->hauteur;i++){
                                         for(j=0;j<m->hauteur;j++){
                                                 resultat=fixerLaValeurDUnElement(resultat,i,j,zero);
                                         }
                                         resultat=fixerLaValeurDUnElement(resultat,i,i,obtenirLaValeurDUnElement(m,i,i));
                                 }
                                 return resultat;
                         }
                 }
         }
 }


 //==========
 //Retourne NULL et erreur 603 si m est introuvable
 Matrice calculerLaMatriceTriangulaireSuperieure(Matrice m){
         Matrice resultat;
         ReelInfini zero;
         int i,j;

         enregistrerLesErreurs();
         noErreur();

         //Si m est introuvable
         if (m==NULL){
                 signalerErreurGroupeMatrice(603);
                 return NULL;
         }
         else{
                 //Si m n'est pas carre
                 if(estUneMatriceCarree(m)==0){
                         signalerErreurGroupeMatrice(609);
                         return NULL;
                 }
                 else{
                         resultat=creerUneMatrice(m->hauteur,m->hauteur);
                         //S'il y a une erreur lorsqu'on cree une nouvelle matrice
                         if(verifierErreur()){
                         				 signalerErreurGroupeMatrice(602);
                                 return NULL;
                         }
                         else{
                                 zero=creerUnReelInfiniAPartirDe("0","0",'+');
                                 for(i=0;i<m->hauteur;i++){
                                         for(j=0;j<i;j++){
                                                 resultat=fixerLaValeurDUnElement(resultat,i,j,zero);
                                         }
                                         for(j=i;j<m->hauteur;j++){
                                                 resultat=fixerLaValeurDUnElement(resultat,i,j,obtenirLaValeurDUnElement(m,i,j));
                                         }
                                 }
                         }
                         return resultat;
                 }
         }
 }


 //==========
 //Retourne NULL et erreur 603 si m est introuvable
 Matrice calculerLaMatriceTriangulaireInferieure(Matrice m){
         Matrice resultat;
         ReelInfini zero;
         int i,j;

         enregistrerLesErreurs();
         noErreur();

         //Si m est introuvable
         if (m==NULL){
                 signalerErreurGroupeMatrice(603);
                 return NULL;
         }
         else{
                 //Si m n'est pas carre
                 if(m->hauteur!=m->longueur){
                         signalerErreurGroupeMatrice(609);
                         return NULL;
                 }
                 else{
                         resultat=creerUneMatrice(m->hauteur,m->hauteur);
                         //S'il y a une erreur lorsqu'on cree une nouvelle matrice
                         if(verifierErreur()){
				                         signalerErreurGroupeMatrice(602);
                                 return NULL;
                         }
                         else{
                                 zero=creerUnReelInfiniAPartirDe("0","0",'+');
                                 for(i=0;i<m->hauteur;i++){
                                         for(j=0;j<=i;j++){
                                                 resultat=fixerLaValeurDUnElement(resultat,i,j,obtenirLaValeurDUnElement(m,i,j));
                                         }
                                         for(j=i+1;j<m->hauteur;j++){
                                                 resultat=fixerLaValeurDUnElement(resultat,i,j,zero);
                                         }
                                 }
                         }
                         return resultat;
                 }
         }
 }


 //==========
 //Retourne NULL et erreur 603 si m est introuvable
 Matrice calculerLaMatriceTransposee(Matrice m){
         Matrice resultat;
         int i,j;

         enregistrerLesErreurs();
         noErreur();


         //Si m est introuvable
         if (m==NULL){
                 signalerErreurGroupeMatrice(603);
                 return NULL;
         }
         else{
                 resultat=creerUneMatrice(m->longueur,m->hauteur);
                 if(verifierErreur()){
												 signalerErreurGroupeMatrice(602);
                         return NULL;
                 }
                 else{
                         for(i=0;i<m->hauteur;i++){
                                 for(j=0;j<m->longueur;j++){
                                         resultat=fixerLaValeurDUnElement(resultat,j,i,obtenirLaValeurDUnElement(m,i,j));
                                 }
                         }
                         return resultat;
                 }
         }
 }

 //==========
 //Retourne 0 et erreur 608 si m n'est pas factorisable
 //Retourne -1 et erreur 603 si m est introuvable
 //Retourne -1 et erreur 609 si m n'est pas carre
 //Retourne 1 si 0K
 int factoriserLU(Matrice A,Matrice *L, Matrice *U){
         int i,j,k;
         ReelInfini temp,temp2,temp3,pivot,zero,un;

         enregistrerLesErreurs();
         noErreur();

         //Si m est introuvable
         if (A==NULL){
                 signalerErreurGroupeMatrice(603);
                 return -1;
         }
         else{
                 //Si m n'est pas carre
                 if(A->hauteur!=A->longueur){
                         signalerErreurGroupeMatrice(609);
                         return -1;
                 }
                 else{
                         //si les tailles de A,L et U ne sont pas compatibles
                         if((A->hauteur!=(*U)->hauteur)||(A->hauteur!=(*U)->longueur)||
                                 (A->hauteur!=(*L)->hauteur)||(A->hauteur!=(*L)->longueur)){
                                 signalerErreurGroupeMatrice(604);
                                 return -1;
                         }
                         else{
                                 zero=creerUnReelInfiniAPartirDe("0","0",'+');
                                 un=creerUnReelInfiniAPartirDe("1","0",'+');
                                 //Initialisation pour la matrice L
                                 for(i=0;i<A->hauteur;++i){
                                         for(j=i+1;j<A->hauteur;++j){
                                                 (*L)=fixerLaValeurDUnElement(*L,i,j,zero);
                                         }
                                 }
                                 //Initialisation pour la matrice U
                                 for(i=0;i<A->hauteur;++i){
                                         for(j=0;j<A->longueur;++j){
                                                 (*U)=fixerLaValeurDUnElement(*U,i,j,obtenirLaValeurDUnElement(A,i,j));
                                         }
                                 }
                                 //Mthode LU
                                 for(k=0;k<A->hauteur-1;++k){
                                         pivot=obtenirLaValeurDUnElement((*U),k,k);
                                         if (sontDeuxReelsInfinisEgaux(pivot,zero)){
                                                 if(verifierErreur()){
                                                         signalerErreurGroupeMatrice(607);
                                                         return -1;
                                                 }
                                                 signalerErreurGroupeMatrice(608);
                                                 return -1;
                                         }
                                         else{
                                                 (*L)=fixerLaValeurDUnElement((*L),k,k,un);
                                                 for(i=k+1;i<A->hauteur;++i){
                                                         temp=diviserDeuxReelsInfinis(obtenirLaValeurDUnElement((*U),i,k),pivot);
                                                         if(verifierErreur()){
                                                                 signalerErreurGroupeMatrice(607);
                                                                 return -1;
                                                         }
                                                         (*L)=fixerLaValeurDUnElement((*L),i,k,temp);
                                                         for(j=k+1;j<A->hauteur;++j){
                                                                 temp2=multiplierDeuxReelsInfinis(temp,obtenirLaValeurDUnElement((*U),i,k));
                                                                 temp3=soustraireDeuxReelsInfinis(obtenirLaValeurDUnElement((*U),i,j),temp2);
                                                                 if(verifierErreur()){
                                                                         signalerErreurGroupeMatrice(607);
                                                                         return -1;
                                                                 }
                                                                 (*U)=fixerLaValeurDUnElement(*U,i,j,temp3);
                                                         }
                                                 }
                                         }
                                 }
                                 for(i=0;i<A->hauteur;++i){
                                         for(j=0;j<i;++j){
                                                 (*U)=fixerLaValeurDUnElement(*U,i,j,zero);
                                         }
                                 }
                                 libererReelInfini(temp);
                                 libererReelInfini(temp2);
                                 return 1;
                         }
                 }
         }
 }


 //==========
 //Resoudre le systeme A*x=secondMembre
 //Retourne -1 et erreur 603 si A ou secondMembre est introuvable
 //Retourne -1 et erreur 610 si secondMembre n'est pas un vecteur colonne
 //Retourne -1 et erreur 604 si les tailles de A et secondMembre ne sont pas compatibles
 //Retourne 0 s'il y a pas une solution
 //Retourne 1 si OK
 int resoudreLeSysteme(Matrice A,Matrice secondMembre,Matrice *solution)
 {

         enregistrerLesErreurs();
         noErreur();

         if (A==NULL || secondMembre==NULL)
         {
         signalerErreurGroupeMatrice(604);
         return -1;
         }

         if ( A->hauteur == A->longueur)
         {
                 if (A->longueur!=secondMembre->hauteur)
                 {
                         signalerErreurGroupeMatrice(604);
                         return -1;
                 }
                 if (secondMembre->longueur!=1)
                 {
                         signalerErreurGroupeMatrice(610);
                         return -1;
                 }

                 if (A->longueur!=(*solution)->hauteur)
                 {
                         signalerErreurGroupeMatrice(604);
                         return -1;
                 }
                 if ((*solution)->longueur!=1)
                 {
                         signalerErreurGroupeMatrice(610);
                         return -1;
                 }

         }
         else
         {
                 signalerErreurGroupeMatrice(609);
                 return -1;
         }


         if (estUneMatriceDiagonale(A)==1)
         {
                 return resoudreSystemeAvecMatriceDiagonale( A, secondMembre, solution);
         }
         else
         {
                 if (estUneMatriceTriangulaireInferieur(A)==1)
                 {
                         return resoudreSystemeAvecMatriceTriangulaireInferieur( A, secondMembre, solution);
                 }
                 else
                 {
                         if (estUneMatriceTriangulaireSuperieure(A)==1)
                         {
                                  return resoudreSystemeAvecMatriceTriangulaireSuperieur( A, secondMembre, solution);
                         }
                         else
                         {
                                 Matrice lower = creerUneMatrice(A->hauteur,A->hauteur);
                                 Matrice upper = creerUneMatrice(A->hauteur,A->hauteur);
                                 Matrice mtemp = creerUneMatrice(A->hauteur,A->hauteur);

                                 if( lower==NULL || upper==NULL || mtemp==NULL)
                                 {
                                         signalerErreurGroupeMatrice(602);
                                         return -1;
                                 }

                                 if (factoriserLU(A,&lower, &upper)==1)
                                 {
                                                 if (resoudreSystemeAvecMatriceTriangulaireInferieur( lower, secondMembre, &mtemp)==1)
                                                 {
                                                         if (resoudreSystemeAvecMatriceTriangulaireSuperieur( upper, mtemp, solution)==1)
                                                         {
                                                                 detruireUneMatrice(lower);
                                                                 detruireUneMatrice(upper);
                                                                 detruireUneMatrice(mtemp);
                                                                 return 1;
                                                         }
                                                         else
                                                         {
                                                                 return 0;
                                                         }
                                                 }
                                                 else
                                                 {
                                                         return 0;
                                                 }
                                 }
                                 else
                                 {
                                         return 0;
                                 }
                         }
                 }
         }
 }


//===================================================================================//
//Retourne 0 et erreur 608 si m n'est pas factorisable
//Retourne -1 et erreur 603 si m est introuvable
//Retourne -1 et erreur 609 si m n'est pas carre
//Retourne 1 si 0K
Matrice calculerLaMatriceInverse(Matrice A){
	Matrice I,L,U,X,xIndiceColonne,yIndiceColonne;
	int n,indiceColonne;
	enregistrerLesErreurs();
	noErreur();
	
	//Si A est introuvable
	if (A==NULL){
		signalerErreurGroupeMatrice(603);
		X=NULL;
	}
	else{
		if(estUneMatriceCarree(A)!=1){
				signalerErreur(609);
		}
		else{
			n=obtenirLaHauteur(A);
			I=creerLaMatriceIdentite(n);
			if (factoriserLU(A,&L,&U)!=1){
				// pas d'erreur si c'est pas inversible ??? ou erreur spciale non lower upper isable ?
				X=NULL;
			}
			else{
   			//notre type commence les indices a zro. <- c'est deja crit ds le matrice.h ...
				for(indiceColonne=0;indiceColonne<=n-1;indiceColonne++){
					//fodrait ptet une toile yindeicecolonne ?
					resoudreSysteme(L,obtenirUneColonne(I, indiceColonne),yIndiceColonne);
					//pareil, *xIndiceColonne ?
					if(resoudreSysteme(U,obtenirUneColonne(yIndiceColonne,indiceColonne),xIndiceColonne)==1){
						X=fixerUneColonne(X,xIndiceColonne,indiceColonne);
						}
			  }				
			}
		}
	}
	return(X);
}
