#include <stdio.h>
#include <stdlib.h>
#include "ReelInfini.h"
#include "EntierInfini.h"
#include "OperateursTrigonometriques.h"
#include "OperateursSpeciaux.h"
#include "error.h"

ReelInfini obtenirArcSinus( ReelInfini angle)
{
int test;
test=0;
test=estUnReelInfiniStrictementInferieurAUnEntierInfini(angle,creerUnReelInfiniAPartirDe("1","0",'-'));
test=test+estUnReelInfiniStrictementSuperieurAUnEntierInfini(angle,creerUnReelInfiniAPartirDe("1","0",'+'));

if(test>=1)
	{
	enregistrerErreur(403,"le nombre en entre n'est pas corect");
	signalerErreur(403);
	return(creerUnReelInfiniAPartirDe("4","0",'-'));
	}

else
	{
	ReelInfini epsilon;
	ReelInfini i;
	ReelInfini un;
	ReelInfini arcsin;
	ReelInfini A;
	ReelInfini P;
	ReelInfini zero;
	ReelInfini deux;
	int test;

	zero=creerUnReelInfiniAPartirDe("0","0",'+');
	arcsin=angle;
	epsilon=angle;
	i=un;
	un=creerUnReelInfiniAPartirDe("1","0",'+');
	deux=creerUnReelInfiniAPartirDe("2","0",'+');

	do
		{
		A=multiplierDeuxReelsInfinis(angle,angle);
		epsilon=multiplierDeuxReelsInfinis(epsilon,A);
		epsilon=multiplierDeuxReelsInfinis(epsilon,i);
		epsilon=multiplierDeuxReelsInfinis(epsilon,i);
		P=additionnerDeuxReelsInfinis(i,un);
		epsilon=diviserDeuxReelsInfinis(epsilon,P);
		P=additionnerDeuxReelsInfinis(i,deux);
		epsilon=diviserDeuxReelsInfinis(epsilon,P);
		arcsin=additionnerDeuxReelsInfinis(arcsin,epsilon);
		i=additionnerDeuxReelsInfinis(i,deux);

		}

	while(sontDeuxReelsInfinisEgaux(epsilon,zero));

	libererReelInfini(epsilon);
	libererReelInfini(i);
	libererReelInfini(un);
	libererReelInfini(A);
	libererReelInfini(P);
	libererReelInfini(zero);

	return(arcsin);
	libererReelInfini(arcsin);
		}

}

ReelInfini obtenirSinus( ReelInfini angle)
{
	EntierInfini i;
	ReelInfini P;
	ReelInfini moinsUn;
	ReelInfini epsilon;
	ReelInfini sin;
	ReelInfini A;
	ReelInfini zero;
	int test;

	zero=creerUnReelInfiniAPartirDe("0","0",'+');
	sin=angle;
	moinsUn=creerUnReelInfiniAPartirDe("1","0",'-');
	A=multiplierDeuxReelsInfinis(angle,angle);

	if (sontDeuxReelsInfinisEgaux(angle,zero)==0)
		{
		do
			{
			i=additionnerDeuxEntiersInfinis(i,creerUnEntierInfiniAPartirDe("2",'+'));
			//caclcul d'epsilon
			P=convertirUnEntierInfiniVersUnReelInfini(multiplierDeuxEntiersInfinis(i,additionnerDeuxEntiersInfinis(i,creerUnEntierInfiniAPartirDe("2",'+'))));
			epsilon=multiplierDeuxReelsInfinis(moinsUn,epsilon);
			epsilon=multiplierDeuxReelsInfinis(epsilon,A);
			epsilon=diviserDeuxReelsInfinis(epsilon,P);
			//calcul du sinus
			sin=additionnerDeuxReelsInfinis(sin,epsilon);
			}
		while(epsilon!=zero);
		}
	//liberation des variables internes.
	libererReelInfini(P);
	libererReelInfini(moinsUn);
	libererReelInfini(epsilon);
	libererReelInfini(A);
	libererReelInfini(zero);
	libererEntierInfini(i);
	noErreur();

	return(sin);
	libererReelInfini(sin);
}

ReelInfini signe(ReelInfini);    //fonction renvoyant 1 ou -1 selon le signe de l'argument
ReelInfini obtenirArcTangente(ReelInfini x)	{               //fonction d'obtention de l'ArcTangente
  
  EntierInfini n, nPlusDeux, deuxE, unE;
  ReelInfini xCarre, zeroR, unR, deuxR, moinsUnR , resultat , epsilon , division;
  zeroR = creerUnReelInfiniAPartirDe("0","0",'+');
  unR = creerUnReelInfiniAPartirDe("1","0",'+');
  moinsUnR = creerUnReelInfiniAPartirDe("1","0",'-');
  deuxE = creerUnEntierInfiniAPartirDe("2",'+');
  unE = creerUnEntierInfiniAPartirDe("1",'+');
  xCarre = multiplierDeuxReelsInfinis( x , x );
  resultat = zeroR;
  epsilon = x;
  n = creerUnEntierInfiniAPartirDe("1",'+');
  noErreur();

  if( estUnReelInfiniInferieurAUnReelInfini( x, unR) && estUnReelInfiniSuperieurAUnReelInfini( x, moinsUnR ))  {         // si |x|<=1
    resultat = zeroR;
    epsilon = x;
  
    while( !sontDeuxReelsInfinisEgaux( epsilon , zeroR ))	{        // algorithme de decomposition en serie de Taylor
      resultat = additionnerDeuxReelsInfinis( resultat , epsilon );
      nPlusDeux = additionnerDeuxEntiersInfinis( n , deuxE );
      division = diviserDeuxReelsInfinis( convertirUnEntierInfiniVersUnReelInfini(n) , convertirUnEntierInfiniVersUnReelInfini(nPlusDeux) );
      epsilon = multiplierDeuxReelsInfinis( multiplierDeuxReelsInfinis( epsilon , moinsUnR ) , multiplierDeuxReelsInfinis( xCarre , division ));
      n = nPlusDeux;
    }

  }
  else         // si |x|>1
    return soustraireDeuxReelsInfinis( multiplierDeuxReelsInfinis( diviserDeuxReelsInfinis(obtenirPi(),deuxR) , signe(x) ) , obtenirArcTangente( diviserDeuxReelsInfinis( unR , x )));
  
   
  libererReelInfini(xCarre);              //liberation des variables
  libererReelInfini(zeroR);
  libererReelInfini(unR);
  libererReelInfini(deuxR);
  libererReelInfini(moinsUnR);
  libererReelInfini(epsilon);
  libererReelInfini(division);
  libererEntierInfini(n);
  libererEntierInfini(nPlusDeux);
  libererEntierInfini(deuxE);
  libererEntierInfini(unE);
  
  return resultat; 

}


ReelInfini signe( ReelInfini r) {                // retourne le signe de l'argument en renvoyant 1 ou -1
  if( estUnReelInfiniSuperieurAUnReelInfini( r ,  creerUnReelInfiniAPartirDe("0","0",'+') ) )   
    return  creerUnReelInfiniAPartirDe("1","0",'+');
  else
    return creerUnReelInfiniAPartirDe("1","0",'-');
}


ReelInfini obtenirTangente(ReelInfini r) {       // renvoie la tangente de l'argument

  ReelInfini cosinus, zeroR;
  zeroR= creerUnReelInfiniAPartirDe( "0" , "0", '+');
  noErreur();  

  if( !enregistrerErreur( ERRTRIGO1 , " Reel egal a PI/2 + k*PI : fonction obtenirTangente inutilisable !")) 
    printf("Erreur dans l'enregistrement de l'erreur");
  
   cosinus = obtenirCosinus(r);
  
  if( sontDeuxReelsInfinisEgaux( cosinus , zeroR )) {
    if(!signalerErreur(ERRTRIGO1))
      printf("Erreur dans le signalement de l'erreur\n");
  }  
  else {
    libererReelInfini(zeroR);
    return diviserDeuxReelsInfinis( obtenirSinus(r), cosinus);
  }
  
  libererReelInfini(cosinus);
  return zeroR;
  
}


ReelInfini obtenirCoTangente(ReelInfini r) {       // renvoie la cotangente de l'argument
  
  ReelInfini sinus, zeroR;
  zeroR= creerUnReelInfiniAPartirDe( "0" , "0", '+');
  noErreur();  

  if( 0 == enregistrerErreur( ERRTRIGO2 , " Reel multiple de PI : fonction obtenirCoTangente inutilisable !")) 
    printf("Erreur dans l'enregistrement de l'erreur");
  
   sinus = obtenirSinus(r);
  
  if( sontDeuxReelsInfinisEgaux( sinus , zeroR )) {
    if(!signalerErreur(ERRTRIGO2))
      printf("Erreur dans le signalement de l'erreur\n");
  }  
  else {
    libererReelInfini(zeroR);
    return diviserDeuxReelsInfinis( obtenirCosinus(r), sinus);
  }

  libererReelInfini(sinus);
  return zeroR;  
  
}


ReelInfini obtenirCosinus(ReelInfini x)
{
        ReelInfini cosinus;
        ReelInfini epsilon ;
		ReelInfini numerateur;
		ReelInfini denominateur;
		ReelInfini moinsun;
		ReelInfini RIzero;
		EntierInfini F1denominateur;
		EntierInfini F2denominateur;
        EntierInfini k;
		EntierInfini EI2k;
		EntierInfini EIun;
		EntierInfini EIdeux;


        char* zero ;
		char* un;
		char* deux;
	
		zero=NULL;
		un=NULL;
		deux=NULL;
	
        *zero='0';
		un[0]='1';
		deux[0]='2';
		
		EIun=creerUnEntierInfiniAPartirDe(un,'+');
        	EIdeux=creerUnEntierInfiniAPartirDe(deux,'+');
		RIzero=creerUnReelInfiniAPartirDe(zero,zero,'+');
		cosinus=RIzero;
     	epsilon=creerUnReelInfiniAPartirDe(un,zero,'+');
        k=creerUnEntierInfiniAPartirDe(zero,'+');
        moinsun =creerUnReelInfiniAPartirDe(un,zero,'-');

		

while(estUnReelInfiniSuperieurAUnReelInfini(epsilon,RIzero)|(estUnReelInfiniInferieurAUnReelInfini(epsilon,RIzero)))
	{
    numerateur=obtenirPuissance(moinsun,k);
	EI2k=multiplierDeuxEntiersInfinis(EIdeux,k);
    F1denominateur=additionnerDeuxEntiersInfinis(EI2k,EIun);
	F2denominateur=additionnerDeuxEntiersInfinis(EI2k,EIdeux);
	denominateur=convertirUnEntierInfiniVersUnReelInfini(multiplierDeuxEntiersInfinis(F1denominateur,F2denominateur));
	epsilon=multiplierDeuxReelsInfinis(multiplierDeuxReelsInfinis(epsilon,multiplierDeuxReelsInfinis(x,x)),(multiplierDeuxReelsInfinis(numerateur,denominateur)));
	cosinus=additionnerDeuxReelsInfinis(cosinus,epsilon);
	k=additionnerDeuxEntiersInfinis(k,EIun);
}
libererEntierInfini(F1denominateur);
libererEntierInfini(F2denominateur);
libererEntierInfini(k);
libererEntierInfini(EI2k);
libererEntierInfini(EIun);
libererEntierInfini(EIdeux);
libererReelInfini(moinsun);
libererReelInfini(epsilon);
libererReelInfini(cosinus);
return cosinus;
}

ReelInfini obtenirArcCosinus(ReelInfini x)
{
		int bidon;
		int ERRTRIGO5=405;
		int erreurDejaEnregistree;
		int erreurDansEnregistrement;
		ReelInfini ArcCosinus;
		ReelInfini Pisur2 ;
		ReelInfini RImoinsun;
		ReelInfini RIplusun;
		ReelInfini RIdeux;

		char* zero=NULL;
		char* un=NULL;
		char* deux=NULL;
	
		zero[0]='0';
		un[0]='1';
		deux[0]='2';
	
		RIplusun=creerUnReelInfiniAPartirDe(un,zero,'+');
		RImoinsun=creerUnReelInfiniAPartirDe(un,zero,'-');
		RIdeux=creerUnReelInfiniAPartirDe(deux,zero,'+');

		
		if(NULL==expliquerErreur(ERRTRIGO4))
			{erreurDejaEnregistree=0;}
		else{erreurDejaEnregistree=1;}
		
		if ((estUnReelInfiniInferieurAUnReelInfini(x,RIplusun))|(estUnReelInfiniSuperieurAUnReelInfini(x,RImoinsun)))
			{
			Pisur2=diviserDeuxReelsInfinis(obtenirPi(),RIdeux);
			ArcCosinus=soustraireDeuxReelsInfinis(Pisur2,obtenirArcSinus(x));
			libererReelInfini(RIdeux);
			libererReelInfini(RIplusun);
			libererReelInfini(RImoinsun);
			libererReelInfini(Pisur2);
			noErreur();
			return ArcCosinus;
			}
		else // si x n'appartient pas  [-1 1]
			{ 
			if (erreurDejaEnregistree=1)
				{
				bidon=signalerErreur(ERRTRIGO4);
				}
			else
				{
				erreurDansEnregistrement=enregistrerErreur(ERRTRIGO4,"la fonction ArcCosinus n est definie que entre -1 et un");
				if (erreurDansEnregistrement==0) // si l'enregistrement de l'erreur s'est bien pass
					{
						erreurDejaEnregistree=1; // on considre que l'erreur a bien ete enregistree
						bidon=signalerErreur(ERRTRIGO4);// donc on la signale
					}
				else
					{ bidon=enregistrerErreur(ERRTRIGO5,"l'enregistrement de l'erreur s'est mal effectue mais Arccos n'est definie QUE sur -1 1");
					  bidon=signalerErreur(ERRTRIGO5); // sinon on signale qd meme qu'il y a une erreur
					}
				}
			return x;
		libererReelInfini(Pisur2);		
		libererReelInfini(RImoinsun);		
		libererReelInfini(RIplusun);		
		libererReelInfini(RIdeux);		
		libererReelInfini(ArcCosinus);					}
}
			 
		






