//////////////////////////////////////////////////////////////////
/*                  _             _        ___       __         */
/*    \    /  /\   | \  |   /\   |_) |    |         /  \        */
/*     \  /  /__\  |_/  |  /__\  | \ |    |--      |            */
/*      \/  /    \ | \  | /    \ |_/ |___ |___  .   \__/        */
/*                                                              */
//////////////////////////////////////////////////////////////////


#include<stdlib.h>
#include "Variable.h"
#include "error.h"

#define Entier EntierInfini
#define Reel ReelInfini

void signalerErreurVariable(int);
void enregistrerErreursVariable();


//-------------------------//
//--- Gestion de Erreur ---//
//-------------------------//


Booleen errNonEnreg=Vrai;    // si errNonEnreg=Faux, il faut enregistrer les erreurs

// Signaler une erreur sur les variables :

void signalerErreurVariable(int erreur){

	noErreur();
        signalerErreur(erreur);

}

// Enregistrer les erreurs :

void enregistrerErreursVariable(){

	if (errNonEnreg)
	  {
		enregistrerErreur(231,"Type de variable incorrect");
		enregistrerErreur(241,"Variable : Erreur de malloc (plus de place en memoire)");
		errNonEnreg=Faux;
	  }

}

//---------------------//
//--- Type Variable ---//
//---------------------//


typedef union {

	EntierInfini e;
	ReelInfini r;
	Matrice m;

} Composite;


struct Variable{

	Chaine nom;
	int type;
	Composite valeur;

};

//-----------------------//
//--- Fonctionnalits ---//
//-----------------------//


//Constructeur

Variable nouvelleVariable(Chaine ch){


  Variable var;
        enregistrerErreursVariable();
        noErreur();

        var=(Variable)malloc(sizeof(struct Variable));
	if(var!=NULL)
	  {
		(var->nom)=ch;
		(var->type)=0;
	  }
	else
	  {
		signalerErreurVariable(241);
	  }

	return var;

}


Chaine obtenirNom(Variable var){

	return (var->nom);

}

void fixerVariableEntier(Variable var,EntierInfini val){
	if((var->type)!=0)
	  {
		detruireValeur(var);
	  }
	(var->type)=1;
	(var->valeur.e)=val;

}

void fixerVariableReel(Variable var,Reel val){
	if((var->type)!=0)
	  {
		detruireValeur(var);
	  }
	(var->type)=1;
	(var->valeur.r)=val;

}

void fixerVariableMatrice(Variable var,Matrice val){

	if((var->type)!=0)
	  {
	   	detruireValeur(var);
    	  }
	(var->type)=3;
  	(var->valeur.m)=val;

}

Booleen estUneVariableEntier(Variable var){

	return (var->type)==1;
}

Booleen estUneVariableReel(Variable var){

	return (var->type)==2;

}

Booleen estUneVariableMatrice(Variable var){

	return (var->type)==3;

}

Entier obtenirVariableEntier(Variable var){

	enregistrerErreursListe();
	noErreur();

	if((var->type)==1)
		{return (var->valeur.e);}
	else {signalerErreurVariable(231);}

}

Reel obtenirVariableReel(Variable var){

	enregistrerErreursListe();
	noErreur();

	if((var->type)==2)
		{return (var->valeur.r);}
	else {signalerErreurVariable(231);}

}

Matrice obtenirVariableMatrice(Variable var){

	enregistrerErreursListe();
	noErreur();

	if((var->type)==3)
		{return var->valeur.m;}
	else {signalerErreurVariable(231);}

}

void libererVariable(Variable* var){

	if(((**var).type)!=0)
	  {
	  	detruireValeur(*var);
	  }
	free(*var);
	*var=NULL;

}

void detruireValeur(Variable var){

	switch(var->type)
	   {
	   case 1:libererEntierInfini(&(var->valeur.e));
          break;
	   case 2:libererReelInfini(&(var->valeur.r));
          break;
	   case 3:detruireUneMatrice((var->valeur.m));
          break;
	   default:

	   }

}
