%{
 /*Inclusion des librairies*/
#include <stdio.h>
#include <stdlib.h>
#include "EntierInfini.h"
#include "ReelInfini.h"
#include "max.h"
#include "Terme.h"
#include "cedric.h"
#include "sam.h"

extern int yyerror(char* s);
extern int yylex();

extern FILE *yyin;

int Parse(char *name);

%}

/*Declaration des differents token*/

%union {
  EntierInfini entier;
  ReelInfini reel;
  Matrice matrice;
  char* variable;
  typeRetourneParDollar dollar;
}

%token <entier> NbeEntier
%token <reel> NbeReel

%token A C

%left '=' '+' '-'
%left '*' '/'
%left 'A' 'C'
%left '!'

%type <dollar> Program Expr1 Expr2 Expr3 Expr4 Facteur Terme

%start Program

%%
                                 /*Affichage du resultat*/
Program:fonction                {exit(0);}
  ; 
        
fonction:fonction Expr1';'      {afficher($2);}
  |/*NULL*/                
  ;				

Expr1:Expr2                     {$$=$1;}
  |Expr1'+'Expr1                {$$=addition($1,$3);}
  |Expr1'-'Expr1                {$$=soustraction($1,$3);}
  ;

Expr2:Expr3                     {$$=$1;}
  |Expr2'*'Expr2                {$$=multiplication($1,$3);}
  |Expr2'/'Expr2                {$$=division($1,$3);}
  ;


Expr3:Expr4                     {$$=$1;}
  ;


Expr4:Facteur                   {$$=$1;}
  |Expr4'!'                     {$$=calculDeLaFactorielle($1);}
  ;

Facteur:Terme                   {$$=$1;}
  |'('Expr1')'                  {$$=$2;}
  |Facteur'A'Facteur            {$$=calculDeLArrangement($1,$3);}
  |Facteur'C'Facteur            {$$=calculDeLaCombinaison($1,$3);}
  |'-'Terme                     {printf ("Yacc : On prend l'oppose\n");
                                 $$=prendreOppose($2)}
  ;

Terme:NbeEntier		        {$$=reconnaitreEntier($1);}
  |NbeReel                      {$$=reconnaitreReel($1);}
  ;


%%

	/*Fonctions necessaires*/

int yyerror(char* s)
{
	fprintf(stdout,"Yacc : Erreur a la con :%s\n",s);
	}

int yywrap() 
{ 
        return(1); 
}


int main(int argc,char** argv)
{
  if (argc == 1 || argv[1] == 0){
    fixerPrecision(0);
    printf("virgule.y : Vous ne pourrez pas faire de calcul sur les reels\n");
  }
  else{
    printf("virgule.y : La precision est de %d chiffres apres la virgule\n", atoi(argv[1]));
    fixerPrecision (atoi(argv[1]));
  }
  yyparse();
  return(0);
}


